<?php
    // ***********************************************************************************
    // LMO-Ereignis
    // ***********************************************************************************
    // ***********************************************************************************
    // Copyright etc. spare ich mir.
    // Bitte eMehl an mich, wer's einsetzt.
    // Fr Verbesserungsvorschlge immer offen, Script ist noch nicht perfekt.
    // ***********************************************************************************
    // Liga-Manager Online von Frank Hollwitz
    // http://www.hollwitz.de
    // by: Peter Scherb, 12/2002
    // Anschauen: www.peterscherb.de/svj
    // ***********************************************************************************
    // LMO_EREIGNIS.PHP
    // ***********************************************************************************
    // Funktion:
    // -----------------------------------------------------------------------------------
    // Zur Anzeige der Ereignisse, Notizen
    // ***********************************************************************************
    // Beschreibung:
    // -----------------------------------------------------------------------------------
    // Ins LMO-Verzeichnis kopieren.
    // Das Script luft durch die angegebenen Ligen, sucht nach Notizen im Spieltag
    // und listet diese auf.
    //
    // Einige Routinen hab' ich mir vom LMO-Viewer abgekuckt (Danke Bernd)
    // Auch kann die Steuerungsdatei vom LMO-Viewer bernommen werden, ansonsten hier der Aufbau:
    //
    // <Pfad_zur_Liga_innerhalb_LMO>/<Datei_Name_der_Liga>;<ID_Nr1>[;<ID_Nr1>...]
    // ***
    //
    // z.B. ligen/C2-KS4.l98;4
    // Liganame: C2-KS4.i98
    // Mannschaft-Nr.: 4
    // Endekennzeichen: ***
    //
    // Wie gesagt, aufbau wie die Viewer-Datei
    // Weitere Variablen sind im Einstellungsbereich beschrieben
    // ***********************************************************************************
    // Aufruf:
    // ZeigeEreignis($art, $incFile, $strMannschaft)
    //
    // Art: 1 = Einzelne Liga, LigaFile = Name der Liga mit Pfad, relativ zum Script
    //      2 = Ligen, die sich in der Datei LigaFile befinden
    //
    // LigaFile: Je nach Art, einzelnes Liga-File oder Datei mit den auszugebenden Ligen
    //
    // Mannschaften: nur bei Art=1 String mit den auszugebenden Mannschaften, durch ;
    //               getrennt, sonst ""
    //
    // ***********************************************************************************

    function ZeigeEreignis($art, $incFile, $strMannschaft)
    {
        // Einstellungsbereich
        $alleNotizen = 0;                  // Alle Notizen (=1) oder nur diejenige ...
                                           // ... in denen das Ergebnis -1 ist, ...
                                           // ... d.h. i.d.R. die abgesagten Spiele
        $anzFavorit = 1;                   // Favorit-Anzeige: 0=nein, 1=ja
        $anzLink    = 1;                   // Anzeige Verlinkung des Spieltags mit der
                                           // Tabelle: 0=nein, 1=ja
        $anzDatHerv = 1;                   // Anzeige des Datums hervorgehoben:
                                           // 0=nein, 1=ja
        $anzHervSt  = "<b><font color='#FF80FF'>";
                                           // Wie wird angezeigt (html) Anfang
        $anzHervEnd = "</font></b>";
                                           // Wie wird angezeigt (html) Ende
        $PfadLMO = "../lmo/";              // Pfad zum Script (MIT / am Ende)!
        $spez = "*";                       // Spezialzeichen, welches nicht in den ...
                                           // ... Mannschaftsnamen auftauchen darf zur ...
                                           // ... Kennzeichnung des Dateiendes
        // Ende Einstellungsbereich

        // ----------------------------------------------------------------------------
        // Allgemeine Variablen
        $designFile = $PfadLMO . "lmo-style.css";
        $design     = '<link rel=stylesheet type="text/css" href="' . $designFile . '">';
    	$tabBreite  = 8;
    	$fClass     = "lmost5";
    	$anfZeile   = "<tr><td  class=" . $fClass . " align=left>";
    	$zwiSpaLi   = "</td><td class=" . $fClass . " align=left>";
    	$zwiSpaZent = "</td><td class=" . $fClass . " align=center>";
    	$zwiSpaRe   = "</td><td class=" . $fClass . " align=right>";
    	$endZeile   = "</td></tr>";
    	$pedVS      = 0.83;
        // Ende allgemeine Variablen
        // ----------------------------------------------------------------------------

        // Array fllen:
        // 1 = Einzelmannschaft, $incFile = einzelnes Ergebnis-File
        switch ($art)
        {
            case 1:
            {
                $arrLigaFile[0] = $incFile;
                $arrMeineMannschaften = explode(";", $strMannschaft);
                $arrErgeb = array_merge($arrErgeb, GetEreignisData($incFile, $arrMeineMannschaften, $alleNotizen));
            }
            break;
            // 2 = mehrere Mannschaften, $incFile = Datei mit Ligen
            case 2:
            {
                // Liga-File auf einmal einlesen
                $LigaFile = $incFile;
                $arrFile = file(chop($LigaFile));
                // Einzelne Liga-Files und Favoriten auslesen
            	for ($i = 0; $i <= sizeof($arrFile); $i++)
                {
                    // Endekennung erreicht ?
                    if (substr($arrFile[$i], 0, 1) == $spez)
                    {
                        break;
                    } // Ende if ... (Endekennung erreicht ?)

                    // Kommentar ?
                    if (substr($arrFile[$i], 0, 2) != "//")
                    {
                        $ligaPfad = $PfadLMO . substr($arrFile[$i], 0, strpos($arrFile[$i], ";"));
                        // Favoriten, durch ; getrennt, extrahieren
                        $arrMannschaft = explode(";", substr($arrFile[$i], strpos($arrFile[$i], ";") + 1));
                        // Beim 1. Durchlauf -> Arrays anlegen ...
                        if (!is_array($arrLigaFile))
                        {
                            $arrLigaFile = array(chop($ligaPfad));
                            $arrMeineMannschaften = array($arrMannschaft);
                        }
                        else // ... ansonsten -> Arrays verbinden
                        {
                            array_push($arrLigaFile, chop($ligaPfad));
                            array_push($arrMeineMannschaften, $arrMannschaft);
                        } // Ende if ... (Beim 1. Durchlauf -> Array anlegen ...)

                    } // Ende if ... (Kommentar ?)

                } // Ende for ... (Einzelne Liga-Files und Favoriten auslesen)


                // Einlesen der Ereignisse in's Ergebnisarray
                for ($i = 0; $i < sizeof($arrLigaFile); $i++)
                {
                    $arrErgeb = array_merge($arrErgeb, GetEreignisData($arrLigaFile[$i], $arrMeineMannschaften[$i], $alleNotizen));
                }
            }
        }


        // ------------------------------------------------------------------------------------------------
        // Ausgabe
    	echo $design;
        echo "<body topmargin='0' leftmargin='0'><div align='center'><center>";
        echo "<table><tr><th colspan='9' class=lmomain0>" . "Ereignisse";
            $LigaCounter = -1;
            // Ergebnis-Array durchwandern
            for ($i = 0; $i < sizeof($arrErgeb); $i++)
            {
                // Ligenname nur wenn neue Liga
                if ($i > 0 && $arrErgeb[$i][0] !=$arrErgeb[$i - 1][0] || $i == 0)
                {
                    echo "<tr><td colspan=" . $tabBreite . " class=lmost4>" . $arrErgeb[$i][0] . "</td></tr>";
                    $LigaCounter++;
                } // Ende if ... (Ligenname nur wenn neue Liga)

                $spielTag = $arrErgeb[$i][5];
                // Ausgabe in der Tabelle
        		echo $anfZeile;
        		// Tabellen-Link anzeigen ?
        		if ($anzLink)
        		{
                    echo "<a href=" . $PfadLMO . "lmo.php?file=" . $arrLigaFile[$LigaCounter] . "&action=results&st=" . $spielTag . " target='_self' title='Tabelle/Begegnungen des $spielTag. Spieltages anzeigen'>";
                } // Ende if ... (Tabellen-Link anzeigen)

                echo "Spieltag " . $spielTag;
        		
        		// Tabellen-Link anzeigen ?
        		if ($anzLink)
        		{
                    echo "</a>";
                } // Ende if ... (Tabellen-Link anzeigen)


                echo $zwiSpaLi;

                // Datum hervorgehoben ?
                if ($anzDatHerv)
                {
                    echo $anzHervSt;
                } // Ende if ... (Datum hervorgehoben ?)

                echo $arrErgeb[$i][1];

                // Datum hervorgehoben ?
                if ($anzDatHerv)
                {
                    echo $anzHervEnd;
                } // Ende if ... (Datum hervorgehoben ?)
                echo $zwiSpaLi . $arrErgeb[$i][7];

                // Anzeige des Favoriten
                $istFavorit = $anzFavorit && chop($arrErgeb[$i][3]) == chop($arrErgeb[$i][8]);
                $anzBold = "";
                if ($istFavorit) { $anzBold = "<b>"; }
                echo $zwiSpaRe . $anzBold . $arrErgeb[$i][3];
                if ($istFavorit) { echo "</b>"; }

                echo $zwiSpaZent . " - ";

                // Anzeige des Favoriten
                $istFavorit = $anzFavorit && chop($arrErgeb[$i][4]) == chop($arrErgeb[$i][8]);
                $anzBold = "";
                if ($istFavorit) { $anzBold = "<b>"; }
                echo $zwiSpaLi . $anzBold . $arrErgeb[$i][4];
                if ($istFavorit) { echo "</b>"; }
            } // Ende for ... (Ergebnis-Array durchwandern)

            // Fuzeile
            echo "<tr>";
                echo "<td  class=lmomain2 colspan='9' align=center >";
                    echo "<a href='http://www.peterscherb.de/svj' target='_blank'>";
                    echo "LMO-Ereignisse V " . $pedVS;
                    echo "</a> &copy; " . date("m") . "/" . date("Y") . " <a href='mailto:Peter.Scherb@PeterScherb.de'>";
                    echo "eMehl an Ped</a>";
                echo "</td>";
            echo "</tr>";
        echo "</table>";
    }

    // ------------------------------------------------------------------------------------------------
    function GetEreignisData($arrLigaFile, $arrMeineMannschaften, $alleNotizen)
    {
        // Datei komplett einlesen
    	$arrFile = file($arrLigaFile);

    	$liganame      = substr($arrFile[2], 5);
    	$spiele        = (int)substr($arrFile[6], 8);
        $sizeOfArrFile = sizeof($arrFile);
        // "Header" einlesen
    	for ($i = 0; $i < $sizeOfArrFile; $i++)
        {
    		$check2 = substr($arrFile[$i], 0, 2);
    		$check3 = substr($arrFile[$i], 0, 3);
    		$check4 = substr($arrFile[$i], 0, 4);
    		$check5 = substr($arrFile[$i], 0, 5);
    		$check6 = substr($arrFile[$i], 0, 6);
    		$check7 = substr($arrFile[$i], 0, 7);
    		$check8 = substr($arrFile[$i], 0, 8);
    		$check9 = substr($arrFile[$i], 0, 9);
    		
    		// Anzahl der Spieltage
    	    if($check6 == "Rounds")
            {
    	    	$spieltage = (int)substr($arrFile[$i], 7);
    	    } // Ende if ... (Anzahl der Spieltage)
    	
    	    // Anzahl Teams feststellen
    	    if($check5 == "Teams")
            {
    	    	$anzMannschaften = substr($arrFile[$i], 6, 2);
    	    } // Ende if ... (Anzahl Teams feststellen)
    	
    	    // Favorit feststellen
    	    if($check7 == "favTeam")
            {
    	    	$favTeam = (int)substr($arrFile[$i], 8, 2);
    	    } // Ende if ... (Anzahl Teams feststellen)
    	
    	    // Alle Teams ins Array einlesen
    		if ($check7 == "[Teams]")
            {
    			$i++;
    			for ($j = 1; $j <= $anzMannschaften; $j++)
                {
    				if ($j < 10)
                    {
    					$arrMannsch[$j] = chop(substr($arrFile[$i], 2));
    				}
    				if ($j > 9)
                    {
    					$arrMannsch[$j] = chop(substr($arrFile[$i], 3));
    				}
    	        $i++;
    		    }
    		} // Ende if ... (Alle Teams ins Array einlesen)
    		
    		// hat die Spieltag-Sektion erreicht -> raus
    		if ($check8 == "[Round1]")
            {
                break;
            } // Ende if ... (hat die Spieltag-Sektion erreicht -> raus)

        } // Ende for ... ("Header" einlesen)

		// Favorit als Mannschafts-Name
        $favTeam = $arrMannsch[$favTeam];
    		
        // Schleife Spieltage
        $sizeOfArrFile = sizeof($arrFile);
        for ($spi = $i; $spi <= $sizeOfArrFile; $spi++)
        {
            // Bentigte Daten, auer Anstozeit, einlesen
    		while (substr($arrFile[$spi], 0, 2) != "AT")
            {
                // Schlel
    			$dummy2 = substr($arrFile[$spi], 0, 2);
    			// Wert
    			$dummy  = substr($arrFile[$spi], strpos($arrFile[$spi], "=") + 1);
    			if ($dummy2 == "D1") { $datum1    = chop((string)$dummy);  }
    			if ($dummy2 == "TA") { $heimId    = (int)$dummy ;	      }
    			if ($dummy2 == "TB") { $gastId    = (int)$dummy ;	      }
    			if ($dummy2 == "GA") { $heimTore  = (int)$dummy;           }
	       		if ($dummy2 == "GB") { $gastTore  = (int)$dummy;           }
    			if ($dummy2 == "BE") { $spBericht = $dummy;                }
    			if ($dummy2 == "NT") { $notiz     = chop($dummy);          }
    			
    			if (substr($arrFile[$spi], 0, 6) == "[Round")
                {
    				$spieltag = substr($arrFile[$spi], 6);
    				$spieltag = substr($spieltag, 0, strlen($spieltag) - 2);
    			}
    			$spi++;
    			// Ende erreicht ?
    			if ($spi > $sizeOfArrFile)
                {
                    break;
                }
            }
            // Anstozeit = Ende Spiel-Sektion
            if (substr($arrFile[$spi], 0, 2) == "AT")
            {
                // Anstozeit extrahieren und ...
                $anStZeit = substr($arrFile[$spi], strpos($arrFile[$spi], "=") + 1);
                // ... in Datumsformat konvertieren
                $datum2 = chop((string)date("d.m.Y", $anStZeit));
                // Mannschaftsarray durchlaufen
                for ($j = 0; $j < sizeof($arrMeineMannschaften); $j++)
                {
                    // Sollen alle Notizen angezeigt werden ?
                    switch ($alleNotizen)
                    {
                    case  0:
                        $vglHeimTore = -1;
                        $vglGastTore = -1;
                        break;
                    case 1:
                        $vglHeimTore = $heimTore;
                        $vglGastTore = $gastTore;
                        break;
                    }
                    if ($heimTore == $vglHeimTore && $gastTore == $vglGastTore && $notiz != "" && ($heimId == $arrMeineMannschaften[$j] || $gastId == $arrMeineMannschaften[$j]))
                    {
                        if (!is_array($arrErgeb))
                        {
                            $arrErgeb = array(array($liganame, $datum1, $anStZeit, $arrMannsch[$heimId], $arrMannsch[$gastId], $spieltag, $spBericht, $notiz, $favTeam));
                        }
                        else
                        {
                            $arrDummy = array(array($liganame, $datum1, $anStZeit, $arrMannsch[$heimId], $arrMannsch[$gastId], $spieltag, $spBericht, $notiz, $favTeam));
                        }
                        // Falls Ergebnis schon vorhanden (tritt nur bei mehreren Mannschaften auf)
                        // nicht eintragen
                        for ($k = 0; $k < sizeof($arrErgeb); $k++)
                        {
                            $flag = 0;
                            if ($arrMannsch[$heimId] == $arrErgeb[$k][3] && $arrMannsch[$gastId] == $arrErgeb[$k][4])
                            {
                                $flag = 0;
                                //break;
                            }
                            else
                            {
                                $flag = 1;
                            }
                        }
                        if ($flag == 1)
                        {
                            $arrErgeb = array_merge($arrErgeb, $arrDummy);
                        }
                    }
                }
            }
        }
        return $arrErgeb;
    }

?>